using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Globalization;
using System.IO;
using System.Windows.Forms;
using System.Xml;

namespace Mapresizer_Tool
{
	public class Form1 : System.Windows.Forms.Form
	{
		private const int SCREEN_WIDTH = 1024 / 32;
		private const int SCREEN_HEIGHT = 768 / 32;

		public static NumberFormatInfo provider = new NumberFormatInfo();
		private static XmlDocument doc;
		private static Bitmap memoryBitmap;
		private static int width = 0, height = 0;
		private static int zoom = 1, mouseX = -1, mouseY = -1;

		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button buttonOpen;
		private System.Windows.Forms.Button buttonSave;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.NumericUpDown numericUpDownZoom;
		private System.Windows.Forms.NumericUpDown numericUpDownTop;
		private System.Windows.Forms.NumericUpDown numericUpDownRight;
		private System.Windows.Forms.NumericUpDown numericUpDownBottom;
		private System.Windows.Forms.NumericUpDown numericUpDownLeft;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label labelWidth;
		private System.Windows.Forms.Label labelHeight;

		public Form1()
		{
			//
			// Erforderlich für die Windows Form-Designerunterstützung
			//
			InitializeComponent();

			//
			// TODO: Fügen Sie den Konstruktorcode nach dem Aufruf von InitializeComponent hinzu
			//
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode für die Designerunterstützung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor geändert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.buttonOpen = new System.Windows.Forms.Button();
			this.buttonSave = new System.Windows.Forms.Button();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.numericUpDownTop = new System.Windows.Forms.NumericUpDown();
			this.label1 = new System.Windows.Forms.Label();
			this.numericUpDownRight = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownBottom = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownLeft = new System.Windows.Forms.NumericUpDown();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.numericUpDownZoom = new System.Windows.Forms.NumericUpDown();
			this.label5 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.labelWidth = new System.Windows.Forms.Label();
			this.labelHeight = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownTop)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownRight)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownBottom)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownLeft)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownZoom)).BeginInit();
			this.SuspendLayout();
			// 
			// buttonOpen
			// 
			this.buttonOpen.Location = new System.Drawing.Point(8, 8);
			this.buttonOpen.Name = "buttonOpen";
			this.buttonOpen.Size = new System.Drawing.Size(128, 23);
			this.buttonOpen.TabIndex = 0;
			this.buttonOpen.Text = "Ö&ffnen...";
			this.buttonOpen.Click += new System.EventHandler(this.buttonOpen_Click);
			// 
			// buttonSave
			// 
			this.buttonSave.Location = new System.Drawing.Point(8, 40);
			this.buttonSave.Name = "buttonSave";
			this.buttonSave.Size = new System.Drawing.Size(128, 23);
			this.buttonSave.TabIndex = 1;
			this.buttonSave.Text = "&Speichern unter...";
			this.buttonSave.Click += new System.EventHandler(this.buttonSave_Click);
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.DefaultExt = "xml";
			this.saveFileDialog1.Filter = "Level (*.xml)|*.xml|Alle Dateien (*.*)|*.*";
			this.saveFileDialog1.Title = "Speichern unter";
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.Filter = "Level (*.xml)|*.xml|Alle Dateien (*.*)|*.*";
			this.openFileDialog1.Title = "Öffnen";
			// 
			// pictureBox1
			// 
			this.pictureBox1.BackColor = System.Drawing.Color.Black;
			this.pictureBox1.Cursor = System.Windows.Forms.Cursors.Cross;
			this.pictureBox1.Location = new System.Drawing.Point(144, 8);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(300, 150);
			this.pictureBox1.TabIndex = 8;
			this.pictureBox1.TabStop = false;
			this.pictureBox1.Paint += new System.Windows.Forms.PaintEventHandler(this.pictureBox1_Paint);
			this.pictureBox1.MouseEnter += new System.EventHandler(this.pictureBox1_MouseEnter);
			this.pictureBox1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseMove);
			this.pictureBox1.MouseLeave += new System.EventHandler(this.pictureBox1_MouseLeave);
			// 
			// numericUpDownTop
			// 
			this.numericUpDownTop.Location = new System.Drawing.Point(72, 104);
			this.numericUpDownTop.Maximum = new System.Decimal(new int[] {
																			 1000,
																			 0,
																			 0,
																			 0});
			this.numericUpDownTop.Minimum = new System.Decimal(new int[] {
																			 1000,
																			 0,
																			 0,
																			 -2147483648});
			this.numericUpDownTop.Name = "numericUpDownTop";
			this.numericUpDownTop.Size = new System.Drawing.Size(64, 20);
			this.numericUpDownTop.TabIndex = 3;
			this.numericUpDownTop.ValueChanged += new System.EventHandler(this.numericUpDownTop_ValueChanged);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 104);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 23);
			this.label1.TabIndex = 10;
			this.label1.Text = "Oben:";
			// 
			// numericUpDownRight
			// 
			this.numericUpDownRight.Location = new System.Drawing.Point(72, 128);
			this.numericUpDownRight.Maximum = new System.Decimal(new int[] {
																			   1000,
																			   0,
																			   0,
																			   0});
			this.numericUpDownRight.Minimum = new System.Decimal(new int[] {
																			   1000,
																			   0,
																			   0,
																			   -2147483648});
			this.numericUpDownRight.Name = "numericUpDownRight";
			this.numericUpDownRight.Size = new System.Drawing.Size(64, 20);
			this.numericUpDownRight.TabIndex = 4;
			this.numericUpDownRight.ValueChanged += new System.EventHandler(this.numericUpDownTop_ValueChanged);
			// 
			// numericUpDownBottom
			// 
			this.numericUpDownBottom.Location = new System.Drawing.Point(72, 152);
			this.numericUpDownBottom.Maximum = new System.Decimal(new int[] {
																				1000,
																				0,
																				0,
																				0});
			this.numericUpDownBottom.Minimum = new System.Decimal(new int[] {
																				1000,
																				0,
																				0,
																				-2147483648});
			this.numericUpDownBottom.Name = "numericUpDownBottom";
			this.numericUpDownBottom.Size = new System.Drawing.Size(64, 20);
			this.numericUpDownBottom.TabIndex = 5;
			this.numericUpDownBottom.ValueChanged += new System.EventHandler(this.numericUpDownTop_ValueChanged);
			// 
			// numericUpDownLeft
			// 
			this.numericUpDownLeft.Location = new System.Drawing.Point(72, 176);
			this.numericUpDownLeft.Maximum = new System.Decimal(new int[] {
																			  1000,
																			  0,
																			  0,
																			  0});
			this.numericUpDownLeft.Minimum = new System.Decimal(new int[] {
																			  1000,
																			  0,
																			  0,
																			  -2147483648});
			this.numericUpDownLeft.Name = "numericUpDownLeft";
			this.numericUpDownLeft.Size = new System.Drawing.Size(64, 20);
			this.numericUpDownLeft.TabIndex = 6;
			this.numericUpDownLeft.ValueChanged += new System.EventHandler(this.numericUpDownTop_ValueChanged);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 128);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(56, 23);
			this.label2.TabIndex = 11;
			this.label2.Text = "Rechts:";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 152);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(56, 23);
			this.label3.TabIndex = 12;
			this.label3.Text = "Unten:";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 176);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(56, 23);
			this.label4.TabIndex = 13;
			this.label4.Text = "Links:";
			// 
			// numericUpDownZoom
			// 
			this.numericUpDownZoom.Increment = new System.Decimal(new int[] {
																				100,
																				0,
																				0,
																				0});
			this.numericUpDownZoom.Location = new System.Drawing.Point(72, 72);
			this.numericUpDownZoom.Maximum = new System.Decimal(new int[] {
																			  3200,
																			  0,
																			  0,
																			  0});
			this.numericUpDownZoom.Minimum = new System.Decimal(new int[] {
																			  100,
																			  0,
																			  0,
																			  0});
			this.numericUpDownZoom.Name = "numericUpDownZoom";
			this.numericUpDownZoom.Size = new System.Drawing.Size(64, 20);
			this.numericUpDownZoom.TabIndex = 2;
			this.numericUpDownZoom.Value = new System.Decimal(new int[] {
																			200,
																			0,
																			0,
																			0});
			this.numericUpDownZoom.ValueChanged += new System.EventHandler(this.numericUpDownTop_ValueChanged);
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 72);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(56, 23);
			this.label5.TabIndex = 9;
			this.label5.Text = "Zoom:";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(8, 200);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(56, 23);
			this.label6.TabIndex = 14;
			this.label6.Text = "Breite:";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(8, 224);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(56, 23);
			this.label7.TabIndex = 15;
			this.label7.Text = "Höhe:";
			// 
			// labelWidth
			// 
			this.labelWidth.Location = new System.Drawing.Point(72, 200);
			this.labelWidth.Name = "labelWidth";
			this.labelWidth.Size = new System.Drawing.Size(64, 23);
			this.labelWidth.TabIndex = 7;
			// 
			// labelHeight
			// 
			this.labelHeight.Location = new System.Drawing.Point(72, 224);
			this.labelHeight.Name = "labelHeight";
			this.labelHeight.Size = new System.Drawing.Size(64, 23);
			this.labelHeight.TabIndex = 8;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(648, 421);
			this.Controls.Add(this.labelHeight);
			this.Controls.Add(this.labelWidth);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.numericUpDownZoom);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.numericUpDownLeft);
			this.Controls.Add(this.numericUpDownBottom);
			this.Controls.Add(this.numericUpDownRight);
			this.Controls.Add(this.numericUpDownTop);
			this.Controls.Add(this.pictureBox1);
			this.Controls.Add(this.buttonOpen);
			this.Controls.Add(this.buttonSave);
			this.Controls.Add(this.label1);
			this.Name = "Form1";
			this.Text = "Glow Mapresizer-Tool von Thiemo Mättig";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownTop)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownRight)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownBottom)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownLeft)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownZoom)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt für die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			provider.NumberDecimalSeparator = ".";
			openFileDialog1.FileName = new System.IO.FileInfo(
				Application.ExecutablePath).DirectoryName + Path.DirectorySeparatorChar + "*.xml";
		}

		private void buttonOpen_Click(object sender, System.EventArgs e)
		{
			if (openFileDialog1.ShowDialog() != DialogResult.OK)
				return;
			doc = new XmlDocument();
			try
			{
				System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.WaitCursor;
				doc.Load(openFileDialog1.FileName);
				doCreateMemoryBitmap();
				System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.Default;
			}
			catch
			{
				MessageBox.Show(this, "Dateiformat nicht lesbar!", "Fehler");
			}
		}

		private void buttonSave_Click(object sender, System.EventArgs e)
		{
			if (openFileDialog1.FileName != "")
				saveFileDialog1.FileName =
					(saveFileDialog1.FileName == "" ? "" :
					new System.IO.FileInfo(saveFileDialog1.FileName).DirectoryName + Path.DirectorySeparatorChar) +
					new System.IO.FileInfo(openFileDialog1.FileName).Name;
			if (saveFileDialog1.ShowDialog() != DialogResult.OK)
				return;
			System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.WaitCursor;
			doSave(saveFileDialog1.FileName);
			System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.Default;
		}

		private void doSave(string filename)
		{
			int newWidth = width + (int)numericUpDownLeft.Value + (int)numericUpDownRight.Value;
			int newHeigth = height + (int)numericUpDownTop.Value + (int)numericUpDownBottom.Value;
			doc.DocumentElement.Attributes["width"].Value = newWidth.ToString();
			doc.DocumentElement.Attributes["height"].Value = newHeigth.ToString();
			int top = (int)numericUpDownTop.Value;
			int right = (int)numericUpDownRight.Value;
			int bottom = (int)numericUpDownBottom.Value;
			int left = (int)numericUpDownLeft.Value;

			XmlNodeList tiles = doc.SelectNodes("*/Tile");
			for (int i = tiles.Count - 1; i >= 0; i--)
			{
				int x = Convert.ToInt32(tiles[i].Attributes["x"].Value) + left;
				int y = Convert.ToInt32(tiles[i].Attributes["y"].Value) + top;
				if (x < 0 || y < 0 || x >= newWidth || y >= newHeigth)
				{
					tiles[i].ParentNode.RemoveChild(tiles[i]);
					continue;
				}
				tiles[i].Attributes["x"].Value = x.ToString();
				tiles[i].Attributes["y"].Value = y.ToString();
			}

			// Diese beiden Fälle umwandeln:
			// <Vector3 name="v3_Position" value="54.5,100,1" />
			// <Vector3 name="v3_PrevPosition" value="54.5,100,1" />
			XmlNodeList vectors = doc.SelectNodes(
				"*/Entity/Variables/Vector3[@name='v3_Position' or @name='v3_PrevPosition']");
			for (int i = vectors.Count - 1; i >= 0; i--)
			{
				// Kommt vor, wenn die Entity aufgrund eines anderen Vector3 schon gelöscht wurde.
				if (vectors[i].ParentNode.ParentNode.ParentNode == null)
					continue;
				string v = vectors[i].Attributes["value"].Value;
				string[] vSplitted = v.Split(",".ToCharArray(), 3);
				string[] vXSplitted = vSplitted[0].Split(".".ToCharArray(), 2);
				string[] vYSplitted = vSplitted[1].Split(".".ToCharArray(), 2);
				int x = int.Parse(vXSplitted[0]);
				int y = int.Parse(vYSplitted[0]);
				x += left;
				y += top;
				if (x < 0 || y < 0 || x >= newWidth || y >= newHeigth)
				{
					vectors[i].ParentNode.ParentNode.ParentNode.RemoveChild(
						vectors[i].ParentNode.ParentNode);
					continue;
				}
				v = "";
				v += x.ToString();
				if (vXSplitted.Length > 1)
					v += "." + vXSplitted[1];
				v += ",";
				v += y.ToString();
				if (vYSplitted.Length > 1)
					v += "." + vYSplitted[1];
				v += ",";
				v += vSplitted[2];
				vectors[i].Attributes["value"].Value = v;
			}

			// XML speichern.
			XmlTextWriter writer = new XmlTextWriter(filename,
				System.Text.Encoding.UTF8);
			writer.Formatting = Formatting.Indented;
			writer.Indentation = 0;
			writer.IndentChar = ' ';
			doc.Save(writer);
			writer.Close();

			doCreateMemoryBitmap();
		}

		private void doCreateMemoryBitmap()
		{
			width = Convert.ToInt32(doc.DocumentElement.Attributes["width"].Value);
			height = Convert.ToInt32(doc.DocumentElement.Attributes["height"].Value);
			memoryBitmap = new Bitmap(width, height);
			doDraw(Graphics.FromImage(memoryBitmap));
			numericUpDownTop.Value = 0;
			numericUpDownRight.Value = 0;
			numericUpDownBottom.Value = 0;
			numericUpDownLeft.Value = 0;
			numericUpDownTop_ValueChanged(null, null);
		}

		private void doDraw(Graphics g)
		{
			Brush brush0 = new SolidBrush(Color.FromArgb(255, 127, 127, 127));
			Brush brush1 = new SolidBrush(Color.FromArgb(255, 255, 255, 255));
			Brush brushE = new SolidBrush(Color.FromArgb(160, 0, 255, 0));
			g.Clear(Color.Black);
			try
			{
				foreach (XmlNode tile in doc.SelectNodes("*/Tile[@l=0 or @layer=0 or (not(@l) and not(@layer))]"))
				{
					g.FillRectangle(brush0,
						Convert.ToInt32(tile.Attributes["x"].Value),
						Convert.ToInt32(tile.Attributes["y"].Value), 1, 1);
				}
				foreach (XmlNode tile in doc.SelectNodes("*/Tile[@l>0 or @layer>0]"))
				{
					g.FillRectangle(brush1,
						Convert.ToInt32(tile.Attributes["x"].Value),
						Convert.ToInt32(tile.Attributes["y"].Value), 1, 1);
				}
				foreach (XmlNode xmlEntity in doc.SelectNodes("*/Entity"))
				{
					string[] p = xmlEntity.SelectSingleNode("*/Vector3[@name='v3_Position']/@value").Value.
						Split(",".ToCharArray());
					int x = (int)Math.Floor(Convert.ToDouble(p[0], provider) + 0.5) - 1;
					int y = (int)Math.Floor(Convert.ToDouble(p[1], provider) + 0.5) - 1;
					g.FillRectangle(brushE, x, y, 1, 1);
				}
			}
			catch
			{
				g.Clear(Color.Red);
			}
		}

		private void pictureBox1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			e.Graphics.InterpolationMode = InterpolationMode.NearestNeighbor;
			e.Graphics.SmoothingMode = SmoothingMode.None;
			//e.Graphics.Clear(Color.Black);
			if (memoryBitmap != null)
			{
				e.Graphics.DrawImage(memoryBitmap,
					(int)numericUpDownLeft.Value * zoom,
					(int)numericUpDownTop.Value * zoom,
					width * zoom + (int)(zoom / 2),
					height * zoom + (int)(zoom / 2));
			}
			if (mouseX >= 0)
			{
				e.Graphics.DrawRectangle(new Pen(Color.FromArgb(160, 0, 255, 255)),
					mouseX - SCREEN_WIDTH / 2 * zoom - 1,
					mouseY - SCREEN_HEIGHT / 2 * zoom - 1,
					SCREEN_WIDTH * zoom + 2, SCREEN_HEIGHT * zoom + 2);
			}
		}

		private void numericUpDownTop_ValueChanged(object sender, System.EventArgs e)
		{
			int newWidth = width + (int)numericUpDownLeft.Value + (int)numericUpDownRight.Value;
			int newHeigth = height + (int)numericUpDownTop.Value + (int)numericUpDownBottom.Value;
			zoom = (int)numericUpDownZoom.Value / 100;
			pictureBox1.Size = new Size(newWidth * zoom, newHeigth * zoom);
			labelWidth.Text = newWidth.ToString();
			labelHeight.Text = newHeigth.ToString();
			pictureBox1.Refresh();
		}

		private void pictureBox1_MouseEnter(object sender, System.EventArgs e)
		{
		}

		private void pictureBox1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			mouseX = e.X;
			mouseY = e.Y;
			pictureBox1.Refresh();
		}

		private void pictureBox1_MouseLeave(object sender, System.EventArgs e)
		{
			mouseX = -1;
			pictureBox1.Refresh();
		}
	}
}